package aqua.backend.air

import aqua.backend.{AirFunction, Backend, Generated, Version}
import aqua.definitions.FunctionDef
import aqua.res.AquaRes
import cats.syntax.show.*

object AirBackend extends Backend {

  val ext = ".air"

  override def generate(aqua: AquaRes): Seq[Generated] = {

    val docs = s"""; This file is auto-generated. Do not edit manually: changes may be erased.
                  |; Generated by Aqua compiler: https://github.com/fluencelabs/aqua/.
                  |; If you find any bugs, please write an issue on GitHub: https://github.com/fluencelabs/aqua/issues
                  |; Aqua version: ${Version.version}
                  |
                  |""".stripMargin

    aqua.funcs.toList.map { fr =>
      val airStr = FuncAirGen(fr).generate.show
      val funcDef = FunctionDef(fr)
      Generated("." + fr.funcName + ext, docs + airStr, AirFunction(fr.funcName, airStr, funcDef) :: Nil)
    }
  }
}
